clc
clear
close all

Bs=1.896;
u0=4*pi*10^-7;
Ms=Bs/u0;

a=110;
alpha=2*10^-4;
k=45;
c=0.01;

Hm=1000;
Binit=0;

N=10001;
t_start=0; 
t_end=0.04;

dt=(t_end-t_start)/(N-1);
t=t_start:dt:t_end;
f=50;
w=2*pi*f;
H=Hm*sin(w*t);

JAsteel=JA(Ms, a, alpha, k, c);
JAsteel.hyst_enable=true;

Mrk(1)=0;
Meuler(1)=0;
for i=2:length(H)
    dH=H(i)-H(i-1);
    if dH>=0
        delta=1;
    else
        delta=-1;
    end
    
    q1=JAsteel.JASTEP_d(H(i-1), Mrk(i-1),delta);
    q2=JAsteel.JASTEP_d(H(i-1)+dH/2, Mrk(i-1)+dH/2*q1,delta);
    q3=JAsteel.JASTEP_d(H(i-1)+dH/2, Mrk(i-1)+dH/2*q2,delta);
    q4=JAsteel.JASTEP_d(H(i-1)+dH, Mrk(i-1)+dH*q3,delta);

    Mrk(i)=Mrk(i-1)+dH/6*(q1+2*q2+2*q3+q4);
    Meuler(i)=Meuler(i-1)+dH*JA.DM(H(i),Meuler(i-1),delta,Ms,a,alpha,c,k,JAsteel.hyst_enable);
end


Im=6428*2^0.5;
phi=-90*pi/180;
Iexp=-Im*sin(phi);
Tp=0.05;
i1=Im*sin(w*t+phi)+Iexp*exp(-t/Tp);
i2_init=0;
Psi_init=0;

% 
D1=0.06;
D2=0.08;

h=0.01;
S=(D2-D1)/2*h;
l=pi*(D1+D2)/2;
w1=1;
w2=2000/5;

u=1000;


L22=u*u0*w2^2*S/l;
L2=0.0002*L22;
R2=0.5;


Rb=78.27/5^2;
Lb=0.5/w;


figure(1)
hold on

i2rk=H*l/w2/sqrt(2);
U2_rk=w*u0*Mrk*S*w2/sqrt(2);

i2euler=H*l/w2/sqrt(2);
U2_euler=w*u0*Meuler*S*w2/sqrt(2);

plot(i2rk, U2_rk, '-r')
plot(i2euler,U2_euler, '-b')
grid on

%%
CT=CT_model(JAsteel, S, w1, w2, l, R2, Rb, L2, Lb);

[HL, Psi, i2]=CT.JACalc(t, i1, i2_init, Psi_init);

figure(2)
plot(t,HL);
figure(3)
hold on
plot(t,-i2*w2/w1,'-r');
plot(t,i1,'--b')

figure(4)
plot(HL/w2/sqrt(2),w*Psi/sqrt(2),'b')









