clc
clear
close all

u0=4*pi*10^-7;
Bs=1.896;
Ms=Bs/u0;

a=100;
alpha=2*10^-4;


k=45;


c=0.1;

Hm=1000;
Minit=0;



N=10001;
t_start=0; 
t_end=0.04;

dt=(t_end-t_start)/(N-1);
t=t_start:dt:t_end;
f=50;
w=2*pi*f;
H=Hm*sin(w*t);

JAsteel=JA(Ms, a, alpha, k, c);

JAsteel.hyst_enable=false;

Mrk(1)=0;
Meuler(1)=0;
for i=1:length(H)-1
    dH=H(i+1)-H(i);
    if dH>=0
        delta=1;
    else
        delta=-1;
    end
    
    q1=JAsteel.JASTEP_d(H(i),          Mrk(i),               delta);
    q2=JAsteel.JASTEP_d(H(i)+dH/2, Mrk(i)+dH/2*q1, delta);
    q3=JAsteel.JASTEP_d(H(i)+dH/2, Mrk(i)+dH/2*q2, delta);
    q4=JAsteel.JASTEP_d(H(i)+dH,    Mrk(i)+dH*q3,    delta);

    Mrk(i+1)=Mrk(i)+dH/6*(q1+2*q2+2*q3+q4);
    Meuler(i+1)=Meuler(i)+dH*JA.DM(H(i),Meuler(i),delta,Ms,a,alpha,c,k, JAsteel.hyst_enable);
end

figure(1)
hold on
plot(H,u0*Mrk, '-r')
plot(H,u0*Meuler, '-b')









