clc
clear
close all

Bs=1.896;
u0=4*pi*10^-7;
Ms=Bs/u0;

a=40;
alpha=0.2*10^-4;

k=45;
c=0.01;

Hm=1000;
B_init=0;
M_init=B_init/u0;

N=10001;
t_start=0; 
t_end=0.04;

dt=(t_end-t_start)/(N-1);
t=t_start:dt:t_end;
f=50;
w=2*pi*f;
H=Hm*sin(w*t);

JAsteel=JA(Ms, a, alpha, k, c);
JAsteel.hyst_enable=true;
JAsteel.saturation_anhyst=false;
JAsteel.stabilizeM=false;


% Meuler(1)=M_init;
% for i=2:length(H)
%     dH=H(i)-H(i-1);
%     if dH>=0
%         delta=1;
%     else
%         delta=-1;
%     end
%     Meuler(i)=Meuler(i-1)+dH*JA.DM_dH(H(i),Meuler(i-1),delta,Ms,a,alpha,c,k,JAsteel.hyst_enable);
% end

Mrk=JAsteel.M(H,M_init);
JAsteel.hyst_enable=false;
Mrk_an=JAsteel.M(H,M_init);
JAsteel.hyst_enable=true;

Im=6428*2^0.5;
phi=-90*pi/180;
Iexp=-Im*sin(phi);
Tp=0.05;
i1=Im*sin(w*t+phi)+Iexp*exp(-t/Tp);
i2_init=0;
Psi_init=0;

% 
D1=0.19;
D2=0.31;

h=0.06;
S=(D2-D1)/2*h;
l=pi*(D1+D2)/2;
w1=1;
w2=2000/5;

u=1000;


L22=u*u0*w2^2*S/l;
L2=0.0002*L22;
R2=0.5;


Rb=78.27/5^2;
Lb=0/w;


figure(1)
hold on

i2rk=H*l/w2/sqrt(2);
U2rk=w*u0*Mrk*S*w2/sqrt(2);

i2rk_an=H*l/w2/sqrt(2);
U2rk_an=w*u0*Mrk_an*S*w2/sqrt(2);

plot(i2rk, U2rk, '-r')
plot(i2rk_an,U2rk_an, '-b')


%i2euler=H*l/w2/sqrt(2);
%U2_euler=w*u0*Meuler*S*w2/sqrt(2);

%plot(i2rk, U2_rk, '-r')
%plot(i2euler,U2_euler, '-b')
grid on
